/*---------------------------------------*\
 Text Pre Plugin for Xinha
 -----------------------------------------
 author: Rahul Singh
 e-mail: induscrypt@gmail.com
 
 Based on  Quick Tag Editor Plugin for HTMLArea-3.0
 by Cau guanabara 
\*---------------------------------------*/

function IndusPre(editor) {
  var cfg = editor.config;
  var self = this;

  cfg.registerButton({
	id       : "induspre",
	tooltip  :  this._lc("Box selected text"),
	image    : editor.imgURL("induspre.gif", "IndusPre"), 
	textMode : false,
  	action   : function(editor) { 
               self.buttonPress(editor); 
             }
  });
  cfg.addToolbarElement("induspre", "htmlmode", 1);  
}

IndusPre.prototype.buttonPress = function(editor) { 
	var self = this;
	var sel = editor.getSelectedHTML(); //if npthing, we'll add dummy
	var param = new Object();
	var prenode= null;
	param.editor = editor;	
	
	//if already in block :
	prenode= editor._getFirstAncestor(editor._getSelection(),['pre']);
	if (prenode==null)prenode= editor._getFirstAncestor(editor._getSelection(),['div']);
	if (prenode==null)prenode= editor._getFirstAncestor(editor._getSelection(),['b']);
	if (prenode==null)prenode= editor._getFirstAncestor(editor._getSelection(),['center']);
	
	if (prenode)
		{		
		var c=confirm('Remove '+ prenode.tagName +' box?');
		if(c) {self.unsetPreTag(editor, param,prenode );return; }
		//else create nested inside
		
		c = confirm('Modify existing '+ prenode.tagName +' box ?');
		if(c) 
			{	
			   var prm= self.preloadParams(editor, prenode, sel); 			   
			   self.setPreTag(editor, prm , sel,prenode); 		
				return;		
			}
		
		
		c = confirm('Create another box\n inside this one?');
		if(c) {self.setPreTag(editor, null, sel,null ); return; }
		
		 else return;
 		}

	//Else create box
 	self.setPreTag(editor, null , sel);   
};


// workhorse functions start 

//Create or modify a box
//pops up the dialogs, gets the returned values, applies changes 
//args: editor, (needless)params,slection,node to change if modifying pre-existing
IndusPre.prototype.setPreTag = function(editor, param,sel,cnode) 
{

//popup 
	editor._popupDialog ( "plugin://IndusPre/indus-pre", 
		function( obj ) 
		{//on return, do this
    		if ( !obj ) 
    		{//user must have pressed Cancel
     		 return false;
     		}
     		 //else, OK has returned an obj with "temp1"
     		 var res=obj["templ"];
     		 //extract the element from the tag
     		 var tg= res.match(/^<[a-z]*/i);
     		 
     		 //if modifying an existing box
     		 if (cnode != null)
     		 {
     		  	editor.selectNodeContents(cnode);				
				var shtml=editor.getSelectedHTML();
				HTMLArea.removeFromParent(cnode);
				editor.insertHTML( res + shtml + "</"+(tg[0]).substring(1)+" >" );			 		 
     		 }
     		 
     		 else
     		 {     		 
     		 	//if nothing is selected, create block with some dummy text     		 
     		 	if (  (sel!=null) && (sel.search(/[^\s\r\n]/g)==-1)  )
     		 	editor.insertHTML( res + "This text is boxed " + "</"+(tg[0]).substring(1)+" >" );
     		 	else //surround selected text
     		 	editor.surroundHTML(res,"</"+(tg[0]).substring(1)+" >");
			}//else	
		}, param );
  
//editor.surroundHTML('<pre style="margin: 5px 5px 2px; width: 200px; background-color: rgb(99, 99, 99); float: left;">','</pre>');

};

//If you're already inside a box, remove it
//actually it should allow you to edit, but not in this version

IndusPre.prototype.unsetPreTag = function(editor, param, cnode) {

	//now, as this is nodeType==1, or an element, do 
	//what you can do with an elemnt
	
	editor.selectNodeContents(cnode);
	var t= confirm("Keep Boxed Content?\n Cancel to delete!");
	var shtml=editor.getSelectedHTML();
	HTMLArea.removeFromParent(cnode);
	
		
	if (t) editor.insertHTML(shtml) ;

};



//Loading Params for an existing box
IndusPre.prototype.preloadParams = function(editor, prenode ,sel) 
{

if ( prenode==null ) return;
 var p=prenode;
 var s=p.style; //dprev.style.border
 outparam = {
    f_type    : (p.tagName).toLowerCase(),
    f_width   : s.width,
    f_height  : s.height,
    f_align   : (s.cssFloat).toLowerCase() ,
    f_bgcol   : s.backgroundColor,    
    f_border  : (s.borderTopStyle).toLowerCase(),
    f_bordercol  : s.borderTopColor,
    f_borderwidth  : s.borderTopWidth,
    f_rounded : s.MozBorderRadiusTopleft
  };


 return outparam;

};

	

IndusPre._pluginInfo = {
name          : "IndusPre",
version       : "0.9 - beta",
developer     : "Rahul Singh",
developer_url : "mailto:induscrypt@gmail.com",
c_owner       : "Rahul Singh",
sponsor       : "Independent production",
sponsor_url   : "http://induscrypt.stumbleupon.com",
license       : "htmlArea"
};

IndusPre.prototype._lc = function(string) {
	
	
    return HTMLArea._lc(string, 'IndusPre');
   
   
   };
   
   
//function that gets the values and creates the tag  
//called by the popup html page, creates its return value (params)

function extractValues()
{
	var f=document.form1 ;
	var boxtype= f.lBoxType.options[f.lBoxType.selectedIndex].value ;
	
	var aligntype= null;
	if (f.lAlign.selectedIndex > 0)
	aligntype= f.lAlign.options[f.lAlign.selectedIndex].value ;	
	
	var boxWidth=f.tWidth.value;
		boxWidth=trimString(boxWidth);	
	var boxHeight=f.tHeight.value;
		boxHeight=trimString(boxHeight);	
	var bgColor=f.tBgCol.value;
		bgColor=trimString(bgColor);
	
	var borderstyle= null ;	
	var borderwidth= null;
	var borderColor=null;	
	var borderBevel=false;
	
	if (f.lBorderStyle.selectedIndex > 0)
	{
	 borderstyle= f.lBorderStyle.options[f.lBorderStyle.selectedIndex].value ;	
	 borderwidth=f.lBorderWidth.options[f.lBorderWidth.selectedIndex].value ;	
	 	borderwidth=trimString(borderwidth);
	 borderColor=f.tBorderCol.value;
	 	borderColor=trimString(borderColor);
	 borderBevel=f.cBordBvl.checked;	
	}
   
   
   var boxtag= parseValues( boxtype, aligntype,  boxWidth, boxHeight, bgColor, borderstyle, borderwidth,borderColor,borderBevel );

   return boxtag;
}	


//validate and parse, return a valid tag
//called by extractValues

function parseValues(btype, aligntype ,boxwidth, boxheight,bgcol, brdrstyle, brdrwidth, brdrcol,bordbvl  )
{
	
    
	var strTag= '<' +btype + ' style=" ';
	if (aligntype !=null)
		strTag+='float:'+aligntype+ '; ';
	strTag+='width:' + boxwidth + '; ';
	
	if ( (boxheight.search(/[^\d]/) == -1) )
		strTag+='height:'+boxheight+ '; ';
	
	if ( (bgcol.length > 0) && checkColor(bgcol) )   
		strTag+='background-color:'+bgcol+ '; ';
	
	if (brdrstyle != null )
		{		
			strTag+='border: ' ;	
			 
				strTag+=brdrwidth + ' ';
			if ( (brdrcol.length > 0) && checkColor(brdrcol)  ) 
				strTag+=brdrcol + ' ';		
		
			strTag+=brdrstyle + ' ; ';
			
			if (bordbvl) 
				strTag+=' -moz-border-radius:15px; padding-left: 15px; padding-right: 15px; padding-top: 5px; ';				
	
		}
	
	
	//close tag, add some addiotional info
	//note- if all margins are equal, FF will collapse them to one
	strTag += 'margin-top: 3px; margin-right:5px; margin-bottom: 3px; margin-left: 6px; " >'
	return strTag;	
	
}


//emulate  java's 'trim'

function trimString(str) { 
    str=str.replace(/^\s*/, '');
    str=str.replace(/\s*$/, '');
   	return str;
} 

//color -rgb and html - validity, checks for accidental deletions at least
function checkColor(colorstring)
{	
    var rgbcheck = /^rgb\(\s*\d{1,3}\s*,\s*\d{1,3}\s*,\s*\d{1,3}\s*\)/i  ; 
    var htmlcheck= /^#[a-f0-9]{6}/i ;    
    return ( (colorstring.search(htmlcheck) > -1) || ( colorstring.search(rgbcheck) > -1) ) 

}
